VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "FishFa30 : CVKGeschwind"
   ClientHeight    =   5295
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8205
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "CVKGeschwind.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5295
   ScaleWidth      =   8205
   StartUpPosition =   3  'Windows-Standard
   Begin VB.TextBox txtAbstandLicht 
      Alignment       =   1  'Rechts
      Height          =   375
      Left            =   3960
      TabIndex        =   7
      Text            =   "165 mm"
      Top             =   4680
      Width           =   735
   End
   Begin VB.TextBox txtLaengeAuto 
      Alignment       =   1  'Rechts
      Height          =   375
      Left            =   2400
      TabIndex        =   6
      Text            =   "60 mm"
      Top             =   4680
      Width           =   735
   End
   Begin VB.ListBox lstAusgabe 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3180
      ItemData        =   "CVKGeschwind.frx":030A
      Left            =   360
      List            =   "CVKGeschwind.frx":0326
      TabIndex        =   4
      Top             =   840
      Width           =   7455
   End
   Begin VB.ComboBox cboPortName 
      Height          =   315
      ItemData        =   "CVKGeschwind.frx":04E1
      Left            =   4920
      List            =   "CVKGeschwind.frx":04FD
      TabIndex        =   3
      Text            =   "Combo1"
      Top             =   4680
      Width           =   1335
   End
   Begin VB.CommandButton cmdEnde 
      Caption         =   "&ENDE"
      Height          =   375
      Left            =   360
      TabIndex        =   1
      Top             =   4680
      Width           =   1335
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "&START"
      Height          =   375
      Left            =   6480
      TabIndex        =   0
      Top             =   4680
      Width           =   1335
   End
   Begin VB.Label Label3 
      Caption         =   "Licht"
      Height          =   255
      Left            =   3360
      TabIndex        =   9
      Top             =   4800
      Width           =   495
   End
   Begin VB.Label Label2 
      Caption         =   "Auto"
      Height          =   250
      Left            =   1920
      TabIndex        =   8
      Top             =   4800
      Width           =   375
   End
   Begin VB.Label Label1 
      Caption         =   "Geschwindigkeitsbestimmung mit einer Doppellichtschranke"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   11.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   480
      TabIndex        =   5
      Top             =   240
      Width           =   5775
   End
   Begin VB.Image Image1 
      Height          =   375
      Left            =   6840
      Picture         =   "CVKGeschwind.frx":0530
      Stretch         =   -1  'True
      Top             =   240
      Width           =   765
   End
   Begin VB.Label lblStatus 
      Alignment       =   2  'Zentriert
      BackColor       =   &H80000009&
      Caption         =   "START/ENDE"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   300
      Left            =   360
      TabIndex        =   2
      Top             =   4200
      Width           =   7455
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ----------------------------------------------------------------------------------------
'
' frmMain(CVKGeschwind.frm)                                         Ulrich Mller 09.11.03
'                                                                   PCS1700          VB6.0
' Doppellichtschranke als Geschwindigkeitsmesser
'
' nach CVK Bauanleitung "Computing Messen-Steuern-Regeln"
'
' ber die beiden Augnge M1 und M2 und die beiden Eingnge E1 und E2 werden zwei Licht-
' schrankenstrecken angesteuert. Ein Gegenstand (etwa ein Spielzeugauto) durchfhrt zuerst
' die Schranke 1 und dann die Schranke 2. Die Passierzeiten werden gemmessen. ber die
' Gegenstandslnge knnen die Passiergeschwindigkeiten durch die Schranken und ber den
' Lichtschrankenabstand die Geschwindigkeit zwischen den Schranken bestimmt werden.
'
' Basis : Template ftComputing30 mit FishFa30.DLL und umFish30.DLL
'
' -----------------------------------------------------------------------------------------

Option Explicit


Const mS1Lampe = 1, eS1Photo = 1, mS2Lampe = 2, eS2Photo = 2

Private Declare Function GetTickCount Lib "kernel32" () As Long

Dim ft As New FishFace
Dim S1AZeit&, S1EZeit&, S2AZeit&, S2EZeit&, MessungNr&
Dim LaengeAuto&, AbstandLicht&




Private Sub Action()
' --- Schleife mit der Messung ------------------------
'     Abbruch durch Finish : HALT-Button oder ESC-Taste
  Do
    ft.WaitForLow eS1Photo
    S1AZeit = GetTickCount
    lblStatus = "--- in S1 eingefahren ---"
    ft.WaitForHigh eS1Photo
    S1EZeit = GetTickCount
    lblStatus = "--- aus S1 ausgefahren ---"
    ft.WaitForLow eS2Photo
    S2AZeit = GetTickCount
    lblStatus = "--- in S2 eingefahren ---"
    ft.WaitForHigh eS2Photo
    S2EZeit = GetTickCount
    lblStatus = "--- Messung abgeschlossen ---"
    Auswertung
  Loop Until ft.Finish()
  
End Sub

Private Sub Auswertung()
' --- Auswertung der Messungen, Anzeige ins lstAusgabe ----
'     Bei Abbruch keine Auswertung

  If ft.Finish() Then Exit Sub
  MessungNr = MessungNr + 1
  lstAusgabe.AddItem " "
  lstAusgabe.AddItem "Messung Nr.: " & MessungNr
  lstAusgabe.AddItem "Schranke 1 Anfang : " & "0"
  lstAusgabe.AddItem "Schranke 1 Ende   : " & Format((S1EZeit - S1AZeit) / 1000#, "00.00") & " Sekunden"
  lstAusgabe.AddItem "Schranke 2 Anfang : " & Format((S2AZeit - S1AZeit) / 1000#, "00.00") & " Sekunden"
  lstAusgabe.AddItem "Schranke 2 Ende   : " & Format((S2EZeit - S1AZeit) / 1000#, "00.00") & " Sekunden"

  AuswertungTeil2             ' --- Bestimmung der Geschwindigkeiten
  lstAusgabe.ListIndex = lstAusgabe.ListCount - 1
  
End Sub

Private Sub AuswertungTeil2()
' --- Bestimmung der Geschwindigkeiten -------------------
  Dim w1!, w2!, w3!, w4!

  lstAusgabe.AddItem " "
  lstAusgabe.AddItem "Auswertung                   Weg [m] Zeit[s] v[m/s]  [km/h]"
  
  w1 = LaengeAuto / 1000#
  w2 = (S1EZeit - S1AZeit) / 1000#
  w3 = w1 / w2
  w4 = w3 * 3.6
  lstAusgabe.AddItem "Schranke 1 A - Schranke 1 E : " & Format(w1, "0.000   ") & _
                     Format(w2, "#0.00   ") & Format(w3, "0.000   ") & Format(w4, "0.000")
  
  w1 = LaengeAuto / 1000#
  w2 = (S2EZeit - S2AZeit) / 1000#
  w3 = w1 / w2
  w4 = w3 * 3.6
  lstAusgabe.AddItem "Schranke 2 A - Schranke 2 E : " & Format(w1, "0.000   ") & _
                     Format(w2, "#0.00   ") & Format(w3, "0.000   ") & Format(w4, "0.000")
  
  w1 = AbstandLicht / 1000#
  w2 = (S2AZeit - S1AZeit) / 1000#
  w3 = w1 / w2
  w4 = w3 * 3.6
  lstAusgabe.AddItem "Schranke 1 A - Schranke 2 A : " & Format(w1, "0.000   ") & _
                     Format(w2, "#0.00   ") & Format(w3, "0.000   ") & Format(w4, "0.000")
  
  w1 = AbstandLicht / 1000#
  w2 = (S2EZeit - S1EZeit) / 1000#
  w3 = w1 / w2
  w4 = w3 * 3.6
  lstAusgabe.AddItem "Schranke 1 E - Schranke 2 E : " & Format(w1, "0.000   ") & _
                     Format(w2, "#0.00   ") & Format(w3, "0.000   ") & Format(w4, "0.000")
  
End Sub

Private Sub cmdAction_Click()
  
' --- Steuern des Modellbetriebs ------------------------------

On Error GoTo ftiFehler

' --- Init-Werte ----------------------------
  LaengeAuto = Val(txtLaengeAuto)
  If LaengeAuto = 0 Then LaengeAuto = 60
  AbstandLicht = Val(txtAbstandLicht)
  If AbstandLicht = 0 Then AbstandLicht = 165

' --- Herstellen der Verbindung zum Interface
  ft.OpenInterface cboPortName.Text, True
  
' --- Steuerung des Programmablaufs ----
  cmdAction.Enabled = False
  cmdEnde.Caption = "&HALT"
  lblStatus.Caption = "Luft"
  lstAusgabe.Clear
' --- Einschalten der Lampen und "Anwrmen" der Photowiderstnde/-transistoren
  ft.SetMotor mS1Lampe, ftiEin
  ft.SetMotor mS2Lampe, ftiEin
  ft.Pause 1234
  MessungNr = 0
  lblStatus = "--- Messung starten ---"
  
    Action         ' --- hier geht's los
  
' --- Aufrumen -------------------------
  ft.ClearMotors
  ft.CloseInterface
  
  cmdAction.Enabled = True
  cmdEnde.Caption = "&ENDE"
  lblStatus.Caption = "START/ENDE"
  cmdEnde.SetFocus
  Exit Sub
  
ftiFehler:                      ' --- Fehlerbehandlung ---
  lblStatus = Err.Number & " : " & Err.Source & "." & Err.Description
  ft.CloseInterface
  cmdEnde.Caption = "&ENDE"
End Sub


Private Sub cmdEnde_Click()

  If cmdEnde.Caption = "&HALT" Then ft.NotHalt = True Else Unload Me
  
End Sub


Private Sub Form_Load()

  cboPortName.ListIndex = 0
  
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

  If cmdEnde.Caption = "&HALT" Then Cancel = 1
  
End Sub

